﻿using UnityEngine;
using System.Collections.Generic;
using UnityEngine.UI;
using UnityEngine.SceneManagement;
using HarmonyLib;

public class UIScalerRedux : Mod
{
    Harmony harmony;
    static float scale = 1;
    static Dictionary<CanvasScaler, Vector2> scalers;
    public void Start()
    {
        scalers = new Dictionary<CanvasScaler, Vector2>();
        harmony = new Harmony("com.aidanamite.UIScalerRedux");
        harmony.PatchAll();
        foreach (var canvas in Resources.FindObjectsOfTypeAll<CanvasScaler>())
            scalers.Add(canvas, canvas.referenceResolution);
        SceneManager.sceneLoaded += OnSceneEvent;
        Log("Mod has been loaded!");
        if (ExtraSettingsAPI_Loaded)
            ExtraSettingsAPI_SettingsClose();
    }

    void OnSceneEvent(Scene scene, LoadSceneMode mode)
    {
        foreach (var canvas in Resources.FindObjectsOfTypeAll<CanvasScaler>())
            if (scalers.TryAdd(canvas, canvas.referenceResolution))
                canvas.referenceResolution *= scale;
            else
                canvas.referenceResolution = scalers[canvas] * scale;
    }

    [ConsoleCommand(name: "resetUIScale", docs: "Resets the UI scale. Best used if you set it too large to access the settings")]
    public string MyCommand(string[] args)
    {
        ExtraSettingsAPI_SetSliderValue("scale", 1);
        ExtraSettingsAPI_SettingsClose();
        return "";
    }

    public void OnModUnload()
    {
        foreach (var canvas in scalers)
            canvas.Key.referenceResolution = canvas.Value;
        harmony.UnpatchAll(harmony.Id);
        Log("Mod has been unloaded!");
    }

    static Traverse ExtraSettingsAPI_Traverse;
    static bool ExtraSettingsAPI_Loaded = false;

    public void ExtraSettingsAPI_Load() => ExtraSettingsAPI_SettingsClose();
    public void ExtraSettingsAPI_SettingsClose()
    {
        scale = 1 / ExtraSettingsAPI_GetSliderValue("scale");
        foreach (var e in scalers)
            e.Key.referenceResolution = e.Value * scale;
    }

    public float ExtraSettingsAPI_GetSliderValue(string SettingName)
    {
        if (ExtraSettingsAPI_Loaded)
            return ExtraSettingsAPI_Traverse.Method("getSliderValue", new object[] { this, SettingName }).GetValue<float>();
        return 0;
    }
    public void ExtraSettingsAPI_SetSliderValue(string SettingName, float value)
    {
        if (ExtraSettingsAPI_Loaded)
            ExtraSettingsAPI_Traverse.Method("setSliderValue", new object[] { this, SettingName, value }).GetValue();
    }
}